

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 MediumPurple
#property indicator_color2 Salmon
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_color5 DarkGreen

extern string Symbol_1 = "GBPUSD";
extern string Symbol_2 = "EURUSD";
extern bool Revers = FALSE;
extern int Period_1 = 12;
extern int Period_2 = 26;
extern int Bars_Counted = 1000;
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];
double g_ibuf_124[];
double g_ibuf_128[];
string gs_132;
string g_symbol_140;
string g_symbol_148;
string g_text_156;
string g_text_164;
string gs_dummy_172;
double gd_180;
double gd_188;
double g_iclose_196;
double g_iclose_204;
double gd_212;
double gd_220;
double gd_228;
double gd_236;
bool gi_244;
bool gi_248;
int g_count_252;
int gi_256;

void init() {
   IndicatorBuffers(6);
   IndicatorDigits(Digits + 1);
   SetIndexBuffer(0, g_ibuf_112);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexLabel(0, "");
   SetIndexBuffer(1, g_ibuf_116);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexLabel(1, "");
   SetIndexBuffer(2, g_ibuf_120);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(2, "MACD " + Symbol_1);
   SetIndexBuffer(3, g_ibuf_124);
   SetIndexStyle(3, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(3, "MACD " + Symbol_2);
   SetIndexBuffer(4, g_ibuf_128);
   SetIndexStyle(4, DRAW_LINE, STYLE_DOT, 1);
   SetIndexLabel(4, "Spread");
   SetIndexBuffer(5, g_ibuf_108);
   SetLevelStyle(2, 1, Silver);
   SetLevelValue(0, 0);
   gi_244 = TRUE;
}

double f0_3(string a_symbol_0, int ai_8) {
   double ld_ret_12 = (iMA(a_symbol_0, 0, Period_1, 0, MODE_EMA, PRICE_CLOSE, ai_8) - iMA(a_symbol_0, 0, Period_2, 0, MODE_EMA, PRICE_CLOSE, ai_8)) / MarketInfo(a_symbol_0,
      MODE_POINT);
   return (ld_ret_12);
}

void start() {
   if (gi_244) {
      f0_1();
      gi_244 = FALSE;
      gi_248 = FALSE;
      gd_212 = 0;
      gd_220 = 0;
      g_iclose_196 = 0;
      g_iclose_204 = 0;
      gd_180 = 0;
      gd_188 = 0;
      gd_228 = 0;
      gd_236 = 0;
      g_count_252 = 1;
      gi_256 = 1;
   }
   int ind_counted_4 = IndicatorCounted();
   if (Bars_Counted <= 0) Bars_Counted = Bars;
   for (int li_0 = Bars_Counted - ind_counted_4 - 1; li_0 >= 0; li_0--) {
      g_ibuf_120[li_0] = f0_3(Symbol_1, iBarShift(Symbol_1, 0, Time[li_0], FALSE));
      g_ibuf_124[li_0] = f0_3(Symbol_2, iBarShift(Symbol_2, 0, Time[li_0], FALSE));
      if (Revers) g_ibuf_108[li_0] = g_ibuf_120[li_0] + g_ibuf_124[li_0];
      else g_ibuf_108[li_0] = g_ibuf_120[li_0] - g_ibuf_124[li_0];
      g_ibuf_112[li_0] = g_ibuf_108[li_0];
      g_ibuf_116[li_0] = g_ibuf_108[li_0];
      if (g_ibuf_108[li_0] < g_ibuf_108[li_0 + 1]) g_ibuf_112[li_0] = EMPTY_VALUE;
      if (g_ibuf_108[li_0] > g_ibuf_108[li_0 + 1]) g_ibuf_116[li_0] = EMPTY_VALUE;
      if (gi_248) {
         gd_180 += iClose(Symbol_1, Period(), iBarShift(Symbol_1, 0, Time[li_0])) - g_iclose_196;
         if (Revers) gd_188 -= iClose(Symbol_2, Period(), iBarShift(Symbol_2, 0, Time[li_0])) - g_iclose_204;
         else gd_188 += iClose(Symbol_2, Period(), iBarShift(Symbol_2, 0, Time[li_0])) - g_iclose_204;
         g_iclose_196 = iClose(Symbol_1, Period(), iBarShift(Symbol_1, 0, Time[li_0]));
         g_iclose_204 = iClose(Symbol_2, Period(), iBarShift(Symbol_2, 0, Time[li_0]));
         g_ibuf_128[li_0] = gd_180 / MarketInfo(Symbol_1, MODE_POINT) - gd_188 / MarketInfo(Symbol_2, MODE_POINT);
         g_count_252++;
         if (MathAbs(gd_180 / MarketInfo(Symbol_1, MODE_POINT) - gd_188 / MarketInfo(Symbol_2, MODE_POINT)) > gd_212) gd_212 = MathAbs(gd_180 / MarketInfo(Symbol_1, MODE_POINT) - gd_188 / MarketInfo(Symbol_2, MODE_POINT));
         gd_220 += MathAbs(gd_180 / MarketInfo(Symbol_1, MODE_POINT) - gd_188 / MarketInfo(Symbol_2, MODE_POINT));
      }
      if (g_ibuf_108[li_0] < 0.0 && g_ibuf_108[li_0 + 1] >= 0.0 && g_ibuf_108[li_0 + 2] >= 0.0) {
         gs_132 = "Max Spread = " + DoubleToStr(gd_212, 0) + "  Avr Spread = " + DoubleToStr(gd_220 / g_count_252, 1);
         f0_0(li_0);
         f0_2(iTime(NULL, 0, li_0), gs_132);
      }
      if (g_ibuf_108[li_0] > 0.0 && g_ibuf_108[li_0 + 1] <= 0.0 && g_ibuf_108[li_0 + 2] <= 0.0) {
         gs_132 = "Max Spread = " + DoubleToStr(gd_212, 0) + "  Avr Spread = " + DoubleToStr(gd_220 / g_count_252, 1);
         f0_0(li_0);
         f0_2(iTime(NULL, 0, li_0), gs_132);
      }
   }
   g_symbol_140 = Symbol_1;
   g_symbol_148 = Symbol_2;
   g_text_156 = "Max Spread = " + DoubleToStr(gd_228, 0);
   g_text_164 = "Avr Spread = " + DoubleToStr(gd_236 / (gi_256 - 2), 1);
   ObjectSetText("Label_1", g_symbol_140, 11, "Arial", Red);
   ObjectSetText("Label_2", g_symbol_148, 11, "Arial", Blue);
   ObjectSetText("Label_3", g_text_156, 11, "Arial", DarkGreen);
   ObjectSetText("Label_4", g_text_164, 11, "Arial", DarkGreen);
}

void deinit() {
   ObjectsDeleteAll(EMPTY, OBJ_VLINE);
   ObjectDelete("Label_1");
   ObjectDelete("Label_2");
   ObjectDelete("Label_3");
   ObjectDelete("Label_4");
}

int f0_2(int a_datetime_0, string a_text_4) {
   ObjectCreate(WindowExpertName() + a_datetime_0, OBJ_VLINE, 1, a_datetime_0, 0);
   ObjectSet(WindowExpertName() + a_datetime_0, OBJPROP_COLOR, Red);
   ObjectSet(WindowExpertName() + a_datetime_0, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(WindowExpertName() + a_datetime_0, OBJPROP_WIDTH, 1);
   ObjectSetText(WindowExpertName() + a_datetime_0, a_text_4, 10);
   ObjectsRedraw();
   return (0);
}

int f0_1() {
   ObjectCreate("Label_1", OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0);
   ObjectSet("Label_1", OBJPROP_CORNER, 1);
   ObjectSet("Label_1", OBJPROP_XDISTANCE, 5);
   ObjectSet("Label_1", OBJPROP_YDISTANCE, 20);
   ObjectCreate("Label_2", OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0);
   ObjectSet("Label_2", OBJPROP_CORNER, 1);
   ObjectSet("Label_2", OBJPROP_XDISTANCE, 5);
   ObjectSet("Label_2", OBJPROP_YDISTANCE, 40);
   ObjectCreate("Label_3", OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0);
   ObjectSet("Label_3", OBJPROP_CORNER, 1);
   ObjectSet("Label_3", OBJPROP_XDISTANCE, 5);
   ObjectSet("Label_3", OBJPROP_YDISTANCE, 60);
   ObjectCreate("Label_4", OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0);
   ObjectSet("Label_4", OBJPROP_CORNER, 1);
   ObjectSet("Label_4", OBJPROP_XDISTANCE, 5);
   ObjectSet("Label_4", OBJPROP_YDISTANCE, 80);
   ObjectsRedraw();
   return (0);
}

void f0_0(int ai_0) {
   gi_248 = TRUE;
   if (gd_212 > gd_228) gd_228 = gd_212;
   gd_236 += gd_220 / g_count_252;
   gd_212 = 0;
   gd_220 = 0;
   g_count_252 = 0;
   gi_256++;
   g_iclose_196 = iClose(Symbol_1, Period(), iBarShift(Symbol_1, 0, Time[ai_0]));
   g_iclose_204 = iClose(Symbol_2, Period(), iBarShift(Symbol_2, 0, Time[ai_0]));
   gd_180 = 0;
   gd_188 = 0; 
}                                              